local function HQ_SuperColorAssign(mo)
	if not hq_superform.value then return end
	if not (mo and mo.valid and mo.player) then return end
	if not mo.hqassignedcolor -- Only need this for one frame
		-- Aiai: Insert Blutz Waves here
		if (mo.skin == "aiai"
		or mo.skin == "eggman"
		or mo.skin == "ray") then
			mo.hqsupernumber = 0
			mo.hqassignedcolor = true
		-- Kuze: Heat Mode
		elseif (mo.skin == "tails"
		or mo.skin == "kuze"
		or mo.skin == "arle"
		or mo.skin == "cream"
		or mo.skin == "metalsonic") then
			mo.hqsupernumber = 1
			mo.hqassignedcolor = true
		-- Kiryu: Climax Heat Mode
		elseif (mo.skin == "knuckles" 
		or mo.skin == "kiryu"
		or mo.skin == "mighty"
		or mo.skin == "gamma"
		or mo.skin == "omega"
		or mo.skin == "darkchao"
		or mo.skin == "motobug") then
			mo.hqsupernumber = 2
			mo.hqassignedcolor = true
		-- Majima: Legend Heat Mode
		elseif (mo.skin == "blaze"
		or mo.skin == "majima"
		or mo.skin == "ulala"
		or mo.skin == "amy"
		or mo.skin == "sakura"
		or mo.skin == "espio"
		or mo.skin == "nights"
		or mo.skin == "rouge") then
			mo.hqsupernumber = 3
			mo.hqassignedcolor = true
		elseif (mo.skin == "vyse"
		or mo.skin == "chaos") then
			mo.hqsupernumber = 4
			mo.hqassignedcolor = true
		-- Copen/GV: Anthem
		elseif (mo.skin == "gunvolt" 
		or mo.skin == "copen"
		or mo.skin == "chao"
		or mo.skin == "miku") then
			mo.hqsupernumber = 5
			mo.hqassignedcolor = true
		elseif (mo.skin == "beat"
		or mo.skin == "wonderboy"
		or mo.skin == "doom"
		or mo.skin == "vector") then
			mo.hqsupernumber = 6
			mo.hqassignedcolor = true
		elseif (mo.skin == "herochao"
		or mo.skin == "aigis"
		or mo.skin == "silver") then
			mo.hqsupernumber = 7
			mo.hqassignedcolor = true
		elseif (mo.skin == "shadow") then
			mo.hqsupernumber = 8
			mo.hqassignedcolor = true
		-- Hyper Sonic
		elseif (mo.skin == "sonic"
		or mo.skin == "flicky") then
			mo.hqsupernumber = 9
			mo.hqassignedcolor = true
		else
			return 
		end
		
	end
end
addHook("MobjThinker", HQ_SuperColorAssign, MT_PLAYER)

--Offroad dust? Fuck that.
local function HQ_NoDust(mo)
	if not (hq_offroad.value) then return end
	if not (mo and mo.valid) return end
	if not (mo.target and mo.target.valid) return end
	if mo.target.player.hugequest.huge > 0 then
		mo.flags2 = $ | MF2_DONTDRAW
	else
		mo.flags2 = $ & ~MF2_DONTDRAW
	end
end
addHook("MobjThinker", HQ_NoDust, MT_WIPEOUTTRAIL)

--Friction? Fuck that.
local function HQ_NoGlue(mo)
	if not (hq_huge.value) return end
	if not (mo and mo.valid and mo.player) return end
	if leveltime < TICRATE return end
	
	if mo.player.hugequest.huge > 0
		mo.friction = max($, 62914)
	end
end
addHook("MobjThinker", HQ_NoGlue, MT_PLAYER)


--Pipes? Thwomps? FUCK 'EM.
local ded = {MT_SMK_PIPE, MT_SMK_THWOMP}
for _,i in ipairs(ded) do
	addHook("MobjCollide", function(mo, mo2)
		if not (hq_huge.value) return end
		if not (mo and mo.valid) return end
		if not mo2.player return end
		if mo2.player
			if (mo2.player.hugequest.huge > 0 or mo2.player.hugequest.sparkle > 0) and ((mo2.z <= mo.z + mo.height) and (mo2.z + mo2.height >= mo.z)) -- Height check
				P_KillMobj(mo, mo2, mo2)
			end
		end
	end, i)
end

--Eggbomb Fix--
local function noeggroll (mo, mo2)
	if mo2.player
	and (mo2.player.hugequest.huge > 0
	or mo2.player.hugequest.sparkle > 0)
		if mo2.player.kartstuff[k_itemtype]
			return true
		else
			return false
		end
	end
	return
end
addHook("TouchSpecial", noeggroll, MT_EGGMANITEM)

-- Oops! All Super --
local function hq_instasuper(mo, mo2)
	if not (mo2 and mo2.player) then return end
	
	local p = mo2.player
	if hq_allsuper.value
	and hq_superform.value then
		if not p.hqsuper then
			p.hugequest.sparkle = 99*TICRATE
			p.hugequest.super = 1
			S_ChangeMusic("hqsupr", true, p)
			K_PlayPowerGloatSound(p.mo)
		else
			return true
		end
	end
	return
end
addHook("TouchSpecial", hq_instasuper, MT_RANDOMITEM)

---Item Size Scaling; shoutouts to Titou's Comet weather---
local bigitem = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_BALLHOG, MT_SINK}
for _,i in ipairs(bigitem) do
	addHook("MobjThinker", function(mo)
		if (not hq_huge.value) or (not mo and mo.valid) then return end
		
		if (mo.target and mo.target.valid) and (mo.target.player and mo.target.player.valid) and not mo.beeg then -- fear
			mo.beeg = 1	
			if (mo.target.player.hugequest.huge > 0)
			or mo.target.player.hugequest.super then
				mo.scale = (3*mapobjectscale)/2
				mo.bigmclargehuge = 1
			end
		end
		
		if mo.scale == (mapobjectscale*3)/2
		and mo.bigmclargehuge then
			local addx = FixedMul(mo.momx, mapobjectscale/2)
			local addy = FixedMul(mo.momy, mapobjectscale/2)
			P_TryMove(mo, (mo.x + addx), (mo.y + addy), mo.z, false)		
		end
	end, i)
end

---The Big Ones---
local function ohhhhbanana (mo)
	if not hq_hugesplit.value then return end
	local x = mo.x
	local y = mo.y
	local z = mo.z
	local banan = FixedMul(5*FRACUNIT, mo.scale)
	local boffset = FixedMul(FRACUNIT, mo.scale)
	if (mo.scale >= (3*mapobjectscale)/2 and mo.bigmclargehuge)
	and ((not (cv_weathermod)) or ((cv_weathermod) and ((weathermod.current.id ~= 22) or (weathermod.current.id == 22) and (weathermod.active == false))))
		//print("OHHHH BANANA")
		local split1 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split1.potassium = true
		split1.target = mo.target
		split1.momy = FixedMul(banan, cos(mo.angle))
		split1.momz = FixedMul(banan, sin(ANGLE_45))
		split1.beeg = 1
		local split2 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split2.potassium = true
		split2.target = mo.target
		split2.momx = FixedMul(-banan, cos(mo.angle))
		split2.momz = FixedMul(banan, sin(ANGLE_45))
		split2.beeg = 1
		local split3 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split3.potassium = true
		split3.target = mo.target
		split3.momx = FixedMul(banan, cos(mo.angle))
		split3.momz = FixedMul(banan, sin(ANGLE_45))
		split3.beeg = 1
	end
end
addHook("MobjDeath", ohhhhbanana, MT_BANANA)

local function PraiseBeToBanan(mo)
	if not mo and mo.potassium return end
	if mo.potassium == true
		if not P_IsObjectOnGround(mo)
			mo.flags = $ | MF_NOCLIPTHING
		else
			mo.flags = $ & ~MF_NOCLIPTHING
		end
	end
end
addHook("MobjThinker", PraiseBeToBanan, MT_BANANA)

local function pinball (mo)
	if not hq_hugesplit.value then return end
	local x = mo.x
	local y = mo.y
	local z = mo.z
	local dis = 40
	local ball = FixedMul((dis*FRACUNIT), mo.scale)
	local balldiff = FixedMul(((2*dis)*FRACUNIT), mo.scale)
	local angdiff = ANGLE_45
	local hqspawn = 0
	if (mo.scale >= (3*mapobjectscale)/2 and mo.bigmclargehuge)
	and ((not (cv_weathermod)) or ((cv_weathermod) and ((weathermod.current.id ~= 22) or (weathermod.current.id == 22) and (weathermod.active == false))))
		while hqspawn < 2 -- Thank you micenice
		do
			local split = P_SpawnMobj(x+FixedMul((ball-(balldiff*hqspawn)), cos(mo.angle)), y-FixedMul((ball-(balldiff*hqspawn)), sin(mo.angle)), z, MT_ORBINAUT)
			split.movefactor = 64*mapobjectscale
			split.target = mo.target
			P_InstaThrust(split, (mo.angle+(-ANGLE_22h+(angdiff*hqspawn))), split.movefactor)
			split.bouncy = true
			split.beeg = 1
			hqspawn = $+1
		end
	end
end
addHook("MobjDeath", pinball, MT_ORBINAUT)

local function HQ_Superball(mo)
	if not (mo and mo.valid) then return end
	if not mo.bouncy then return end
	if P_IsObjectOnGround(mo)
	and hq_superball.value then
		mo.momz = FixedMul(min(mo.health, 3)*(2*mo.radius/5), mapobjectscale)
	end
end
addHook("MobjThinker", HQ_Superball, MT_ORBINAUT)

local balls = {MT_ORBINAUT, MT_ORBINAUT_SHIELD}
for _,i in ipairs(balls) do
	addHook("MobjThinker", function(mo)
		if not (mo and mo.valid) then return end
		if not (mo.target and mo.target.valid and mo.target.player) then return end
	
		if mo.target and mo.target.player then
			local pmo = mo.target
			local p = mo.target.player
			if not mo.superglow then
				if p.hqsuper	
					mo.hqsuperglow = 1
				else
					mo.hqsuperglow = -1
				end
			end
		end
		
		if mo.hqsuperglow == 1 then
			mo.hqsupershift = 1
			mo.color = HQ_animSuper[7][mo.hqsupershift]
			if leveltime%5 == 0 then
				if mo.hqsupershift == #HQ_animSuper[7]
					mo.hqsupershift = 1
				else
					mo.hqsupershift = $ + 1
				end
			end
		elseif mo.hqsuperglow == -1 
		and not mo.hqcolorset then
			mo.color = mo.target.player.skincolor
			mo.hqcolorset = true
		end
	end, i)
end

--- Sonic 1 throwback ---
local function classicsonic(mo)
	if not (mo and mo.valid) return end
	if (not hq_sparkle.value) then return end
	if not (mo.target and mo.target.valid and mo.target.player) then return end
	local p = mo.target.player
	local pmo = mo.target
	if p.hugequest.super then
		if p.hugequest.supercolor == -1 then
			if p.hugequest.supershift > 5
			and p.mo.hqsupernumber ~= 9 then
				p.hugequest.supershift = 1
			end

			if p.mo.hqsupernumber ~= nil then
				mo.color = HQ_animSuper[p.mo.hqsupernumber][p.hugequest.supershift]
			else
				mo.color = HQ_animSuper[0][p.hugequest.supershift]
			end
		else
			if p.hugequest.supershift > 5
			and p.hugequest.supercolor.value ~= 9 then
				p.hugequest.supershift = 1
			end
			mo.color = HQ_animSuper[p.hugequest.supercolor][p.hugequest.supershift]
		end
		mo.colorized = true
	else
		--if p.kartstuff[k_invincibilitytimer] >= 3*TICRATE then
			if not (BoostFX and p.bfxflamecolor >= 103)
				mo.color = SKINCOLOR_WHITE
				mo.colorized = true
			end
		--elseif (p.kartstuff[k_invincibilitytimer] > 0
		--and p.kartstuff[k_invincibilitytimer] < 3*TICRATE) then
		--	mo.color = SKINCOLOR_RED
		--	mo.colorized = true
		--end
	end
end
addHook("MobjThinker", classicsonic, MT_SPARKLETRAIL)

local function K_HQNyoom(mo)
	if not (hq_jumpstore.value) or not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) then return end
	
	if mo.target and mo.target.player then
        if mo.target.player.kartstuff[k_driftboost] > 0
        and ((not acrobatics and mo.target.player.kartstuff[k_sneakertimer] > 0)
        or (acrobatics and mo.target.player.kartstuff[k_sneakertimer] > 0 and mo.target.player.tricksneakerbuffer > 0))
			mo.color = SKINCOLOR_HANDHELD
			mo.colorized = true
		else
			if not mo.target.player.bfxlinecolor
				mo.colorized = false
			end
		end
	end
end
addHook("MobjThinker", K_HQNyoom, MT_FASTLINE)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	
	if (mo.target and mo.target.valid)
	and (mo.target.target and mo.target.target.valid and mo.target.target.player)
	and not mo.hqsignset then
		//print("Sign linked to player.")
		//print("Did player finish in Super Form? "..mo.target.target.player.hqsuperfinish)
		if mo.target.target.player.hqsuperfinish
			mo.hqsupersign = true
			//print("Super Finish!")
		end
		mo.hqsignset = 1
		//print("Sign set.")
	end

	if mo.hqsupersign
	and not mo.hqsupergoalset then
		mo.hqsupercycle = 1
		-- Keep Sign color the same even if you change colors after the 
		-- sign spawns
		if mo.target.target.player.hugequest.supercolor == -1 then
			mo.hqsuperglow = mo.target.target.player.mo.hqsupernumber
		else
			mo.hqsuperglow = mo.target.target.player.hugequest.supercolor
		end
		mo.hqsupergoalset = 1 -- This keeps the goalpost the same in case you switch characters while a race is still underway.
	end

	if mo.hqsupergoalset then
		if leveltime%3 == 0 then
			if mo.hqsupercycle >= #HQ_animSuper[mo.hqsuperglow] then
				mo.hqsupercycle = 1
			else
				mo.hqsupercycle = $ + 1
			end
			mo.color = HQ_animSuper[mo.hqsuperglow][mo.hqsupercycle]
		end
	end
end, MT_OVERLAY)

