-------------------------------------------------------------|
---------------HUGE QUEST by RetroStation--------------------|
----------------------and DarkyBenji-------------------------|
-------------------------------------------------------------|
freeslot(
	"sfx_hq",
	"sfx_hqa"
)
sfxinfo[sfx_hq] = {
	flags = SF_X4AWAYSOUND
}
sfxinfo[sfx_hqa]= {
	flags = SF_X4AWAYSOUND
}

rawset(_G, "HugeQuest", "Onihime") -- Heyo!

---------|
--CVars--|
---------|

rawset(_G, "hq_debug" , CV_RegisterVar({
	name = "hq_debug",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_huge" , CV_RegisterVar({
	name = "hq_huge",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if not var.value then
			if (hq_superform.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				CV_StealthSet(CV_FindVar("hq_superform"), "off")
			end
		end
	end
}))

rawset(_G, "hq_offroad" , CV_RegisterVar({
	name = "hq_offroad",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_jumpstore" , CV_RegisterVar({
	name = "hq_jumpstore",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_sparkle" , CV_RegisterVar({
	name = "hq_sparkle",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if not var.value then
			if (hq_superform.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				CV_StealthSet(CV_FindVar("hq_superform"), "off")
			end
		end
	end
}))

rawset(_G, "hq_superform" , CV_RegisterVar({
	name = "hq_superform",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			if not (hq_huge.value and hq_sparkle.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				CV_StealthSet(CV_FindVar("hq_superform"), "off")
			end
		end
	end
}))

rawset(_G, "hq_allsuper" , CV_RegisterVar({
	name = "hq_allsuper",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			if not (hq_huge.value and hq_sparkle.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				CV_StealthSet(CV_FindVar("hq_allsuper"), "off")
			end
		end
	end
}))

rawset(_G, "hq_supercolor" , CV_RegisterVar({
	name = "hq_supercolor",
	defaultvalue = "Dynamic",
	flags = 0,
	PossibleValue = {Dynamic = -1,
					Gold = 0,
					Orange = 1,
					Red = 2,
					Pink = 3,
					Blue = 4,
					Aqua = 5,
					Green = 6,
					White = 7,
					Copper = 8,
					Hyper = 9}
}))

rawset(_G, "hq_dynamictimer" , CV_RegisterVar({
	name = "hq_dynamictimer",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_altsquish" , CV_RegisterVar({
	name = "hq_altsquish",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_hugesplit" , CV_RegisterVar({
	name = "hq_hugesplit",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_superball" , CV_RegisterVar({
	name = "hq_superball",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "growplus", {speedmod = FRACUNIT/10, timer = (12*TICRATE)})

--Init------|
----And-----|
------Sync--|

local function hq_init(p)
	p.hugequest = {
		huge = 0, -- New Grow timer
		sparkle = 0,
		speen = false,
		boom = false,
		tackle = false,
		super = 0, -- Super flag
		supercolor = -1,
		gstacks = 0, -- How many times you've stacked Grow
		istacks = 0,
		supershift = 1, -- Animated Super glow
		leadbuffer = 0, -- Buffer for position shuffles and jankpoints
		--prev tics
		LFitem = 0,
		LFamount = 0
	}
end
addHook("PlayerSpawn", hq_init)